

#include <stdio.h>
#include <string.h>
#include <avr/interrupt.h>
#include "timer.h"
#include "spi.h"
#include "enc28j60.h"
#include "rfm12.h"




static uint8_t PacketBuf[0x700];
static uint16_t PacketBufLength = 0;

static uint8_t TxDelay = 0;




int
main(void)
{
	timer_init();
	spi_init();
	enc28j60_init();
	rfm12_init(PacketBuf, sizeof(PacketBuf));

	sei();

	for (;;) {

		if (timer_Flag10ms) {
			timer_Flag10ms = 0;
			if (TxDelay > 0) {
				TxDelay--;
			}
		}

		rfm12_main();

		if (rfm12_isReceiving()) {
			TxDelay = 3;
		}

		/* Forward packets from RFM12 to ENC28J60 */

		rfm12_readPacket(PacketBuf, &PacketBufLength, sizeof(PacketBuf));
		if (PacketBufLength > 0) {
			enc28j60_writePacket(PacketBuf, PacketBufLength);
			enc28j60_sendPacket();
		}

		/* Forward packets from ENC28J60 to RFM12 */

		if (TxDelay == 0) {
			enc28j60_readPacket(PacketBuf, &PacketBufLength, sizeof(PacketBuf));
			if (PacketBufLength > 0) {
				rfm12_writePacket(PacketBuf, PacketBufLength);
			}
		}

	}

}
