

#include <avr/io.h>




#define PORT_SPI PORTB
#define DDR_SPI  DDRB
#define BIT_SS   PB4
#define BIT_MOSI PB5
#define BIT_MISO PB6
#define BIT_SCK  PB7




void
spi_init(void)
{
	PORT_SPI |= (1 << BIT_SS);
	DDR_SPI |= (1 << BIT_SS) | (1 << BIT_MOSI) | (1 << BIT_SCK);
	DDR_SPI &= ~(1 << BIT_MISO);
	SPCR = (1 << SPE) | (1 << MSTR);
	SPSR = (1 << SPI2X);
}


void
spi_deinit(void)
{
	PORT_SPI = 0;
	DDR_SPI = 0;
	SPCR = 0;
	SPSR = 0;
}


void
spi_select(void)
{
	PORT_SPI &= ~(1 << BIT_SS);
}


void
spi_deselect(void)
{
	PORT_SPI |= (1 << BIT_SS);
}


void
spi_write(uint8_t data)
{
	SPDR = data;
	while (!(SPSR & (1 << SPIF)));
}


uint8_t
spi_read(void)
{
	SPDR = 0x00;
	while (!(SPSR & (1 << SPIF)));
	return SPDR;
}
