

#include <avr/io.h>
#include <avr/interrupt.h>




volatile uint8_t timer_Flag10ms;
volatile uint8_t timer_Flag1s;




void
timer_init(void)
{
	#ifdef __AVR_ATmega644__
		OCR0A  = 249;
		TCCR0A = (1<<WGM01);
		TCCR0B = (1<<CS01) | (1<<CS00);
		TIMSK0 = (1<<OCIE0A);
	#elif __AVR_ATmega32__
		OCR0  = 249;
		TCCR0 = (1<<WGM01) | (1<<CS01) | (1<<CS00);
		TIMSK = (1<<OCIE0);
	#else
		#error
	#endif
}


void
timer_deinit(void)
{
	#ifdef __AVR_ATmega644__
		OCR0A  = 0;
		TCCR0A = 0;
		TCCR0B = 0;
		TIMSK0 = 0;
	#elif __AVR_ATmega32__
		OCR0  = 0;
		TCCR0 = 0;
		TIMSK = 0;
	#else
		#error
	#endif
}


#ifdef __AVR_ATmega644__
	ISR(SIG_OUTPUT_COMPARE0A)
#elif __AVR_ATmega32__
	ISR(SIG_OUTPUT_COMPARE0)
#else
#error
#endif
{
	static uint8_t divider10ms = 0;
	static uint8_t divider1s = 0;

	if (++divider10ms >= 10) {
		divider10ms = 0;
		timer_Flag10ms = 1;
		if (++divider1s >= 100) {
			divider1s = 0;
			timer_Flag1s = 1;
		}
	}
}
